import polynomial, dualbasis, shapes, points, functional, functionalset


class BDM1Dual( dualbasis.DualBasis ):
    def __init__( self , shape , U ):
        DCPE = functional.DirectionalComponentPointEvaluation
        d = shapes.dimension( shape )
        pts_per_edge = [ [ x \
                           for x in points.make_points( shape , \
                                                        d-1 , \
                                                        i , \
                                                        d+1 ) ] \
                        for i in shapes.entity_range( shape , d-1 ) ]
        pts_flat = reduce( lambda a,b:a+b , pts_per_edge )
        ls = [ ]
        for i in range(d+1):
            nrml = shapes.normals[ shape ][ i ]
            ls_cur = [ DCPE(U,nrml,pt) for pt in pts_per_edge[i] ]
            ls.extend(ls_cur)

        entity_ids = {}
        for i in range(d-1) + [d]:
            entity_ids[i] = {}
            for j in shapes.entity_range(shape,i):
                entity_ids[i][j] = []
        pts_per_bdry = len(pts_per_edge[0])
        entity_ids[d-1] = {}
        node_cur = 0
        for j in shapes.entity_range(shape,d-1):
            for k in range(pts_per_bdry):
                entity_ids[d-1][j] = node_cur
                node_cur += 1

        fset = functionalset.FunctionalSet( U , ls )

        dualbasis.DualBasis.__init__( self , fset , entity_ids )

        return
        
class BDM1( polynomial.FiniteElement ):
    """Lowest order Brezzi-Douglas-Marini H(div) finite element
    vectors of linear functions with nodes consisting of two normal
    components on each boundary (edge in 2d, face in 3d)."""
    def __init__( self , shape ):
        U = polynomial.OrthogonalPolynomialArraySet( shape , 1 )
        Udual = BDM1Dual( shape , U )
        polynomial.FiniteElement.__init__( self , Udual , U )
        return
