import shapes, dualbasis, polynomial, Numeric, points, functional
import functionalset

class P0Dual( dualbasis.DualBasis ):
    def __init__( self , shape , U ):
        # get barycenter
        vs = shapes.vertices[shape]
        bary = Numeric.average( Numeric.array( map( Numeric.array , \
                                                   vs.values() ) ) )
        
        ls = [ functional.PointEvaluation( U , bary ) ]
        entity_ids = { }
        d = shapes.dims[ shape ]
        for i in range(d):
            entity_ids[i] = {}
            for j in shapes.entity_range(shape,i):
                entity_ids[i][j] = {}
        entity_ids[d] = { 0 : [ 0 ] }

        fset = functionalset.FunctionalSet( U , ls )

        dualbasis.DualBasis.__init__( self , fset , entity_ids )

class P0( polynomial.FiniteElement ):
    def __init__( self , shape ):
        U = polynomial.OrthogonalPolynomialSet( shape , 0 )
        Udual = P0Dual( shape , U )
        polynomial.FiniteElement.__init__( self , Udual , U )
